

package org.gridminer.jspace.lifecycle;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.DomDriver;


/**
 * @author Ibrahim Elsayed
 * @version 1.0
 * useful utilities
 *
 */
public class MyUtilities {
	
	public static LifeCycleResource convertFromXML(String XMLString) {
		LifeCycleResource lc = null;
		XStream xstream = new XStream(new DomDriver());
		xstream.alias("LifeCycleResource", LifeCycleResource.class);
		xstream.alias("MetaInfo", MetaInfo.class);
		xstream.alias("GoalSpecification", GoalSpecification.class);
		xstream.alias("DataPreparation", DataPreparation.class);
		xstream.alias("TaskSelection", TaskSelection.class);
		xstream.alias("TaskExecution", TaskExecution.class);
		xstream.alias("MetaInfo", MetaInfo.class);
		xstream.alias("ResultsProcessing", ResultsProcessing.class);
		Object obj = xstream.fromXML(XMLString);
		if (obj instanceof LifeCycleResource) {
			lc = (LifeCycleResource) obj;
		}
		return lc;
	}
	
	public static String convertToXML(LifeCycleResource lc) {
		XStream xstream = new XStream(new DomDriver());
		xstream.alias("LifeCycleResource", LifeCycleResource.class);
		xstream.alias("MetaInfo", MetaInfo.class);
		xstream.alias("GoalSpecification", GoalSpecification.class);
		xstream.alias("DataPreparation", DataPreparation.class);
		xstream.alias("TaskSelection", TaskSelection.class);
		xstream.alias("TaskExecution", TaskExecution.class);
		xstream.alias("MetaInfo", MetaInfo.class);
		xstream.alias("ResultsProcessing", ResultsProcessing.class);
		return xstream.toXML(lc);
	}
	
	public static boolean saveMyLifeCycleResourceToXMLFile (String fileName, LifeCycleResource lc) {
		return saveStringToFile(fileName, convertToXML(lc));
	}
	
	public static LifeCycleResource getLifeCycleFromXMLFile (String fileName) {
		return convertFromXML(getStringFromFile(fileName));
	}

	public static String getStringFromFile(String fileName) {
		BufferedReader br = null;
		StringBuilder sb = new StringBuilder();
		
		try {
			br = new BufferedReader(new FileReader(fileName));
			try {
				String s;
				while ((s = br.readLine()) != null) {
					sb.append(s);
					sb.append("\n");
				}
			}
			finally {
				br.close();
			}
		}
		catch(IOException e) {
			e.printStackTrace();
		}
		return sb.toString();
	}
	
	public static boolean saveStringToFile(String fileName, String saveString) {
		boolean saved = false;
		BufferedWriter bw = null;
		
		try {
			bw = new BufferedWriter(new FileWriter(fileName));
			
			try {
				bw.write(saveString);
				saved = true;
			}
			finally {
				bw.close();
			}
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		return saved;
	}
	
	
	public static boolean addStringToFile(String fileName, String saveString) {
		boolean saved = false;
		BufferedWriter bw = null;
		
		try {
			boolean append = true;
			bw = new BufferedWriter(new FileWriter(fileName, append));
			
			try {
				bw.write(saveString);
				saved = true;
			}
			finally {
				bw.close();
			}
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		return saved;
	}
		
	public static String[] splitString(String s) {
		String delims = "[;]+";
		String[] keywords = s.split(delims);
		
		return keywords;
	}
	
}
