package org.gridminer.jspace.queryProcessor;

import org.dbgrid.aderis.*;
import org.dbgrid.aderis.datasource.*;
import org.gridminer.jspace.lifecycle.MyUtilities;

import java.util.*;

public class searchStudy {

   public static void main(String [] args) {

	   long start1 = System.currentTimeMillis();
	   ConfigurationParameters parameters = new ConfigurationParameters();
       
       //DataSource ds1 = new DataSource("http://db02.hpcc.jp:2020/sparql");
       //DataSource ds2 = new DataSource("http://db02.hpcc.jp:2040/sparql");
       DataSource ds1 = new DataSource("http://localhost:2021/sparql");
       DataSource ds2 = new DataSource("http://localhost:2022/sparql");
       DataSource ds3 = new DataSource("http://localhost:2023/sparql");

       Set<DataSource> sources = new HashSet<DataSource>();
       sources.add(ds1);
       sources.add(ds2);
       sources.add(ds3);

       SPARQLQueryProcessor processor = new SPARQLQueryProcessor(parameters,sources);

       System.out.println("Load time (Query Execution): " + (System.currentTimeMillis() - start1) + " msec.");
       
       
       
       String query1 = 	"PREFIX owl: <http://localhost/LifeCycleOntology.owl#> SELECT ?lifeCycle " +
       					"?goalSpecification ?dataPreparation ?taskSelection WHERE { ?lifeCycle " +
       					"owl:hasGoalSpecification ?goalSpecification. ?lifeCycle " +
       					"owl:hasTaskSelection ?taskSelection. ?lifeCycle owl:hasDataPreparation " +
       					"?dataPreparation. }";
                      
       String query2 = "PREFIX owl: <http://localhost/LifeCycleOntology.owl#> SELECT ?s ?p ?o WHERE { ?s ?p ?o }";
       
       String query3 = "PREFIX owl: <http://localhost/LifeCycleOntology.owl#> SELECT ?s ?p WHERE { ?s ?p owl:i.elsayed }";
       
       String query4 = "PREFIX owl: <http://localhost/LifeCycleOntology.owl#> SELECT ?lifeCycle ?goalSpecification ?p ?o WHERE { ?lifeCycle owl:hasGoalSpecification ?goalSpecification. ?lifeCycle ?p ?o. } ";
       
       String query5 = "PREFIX owl: <http://localhost/LifeCycleOntology.owl#> SELECT ?member ?p ?o WHERE { owl:researchGroup_1 owl:hasMembers ?member . ?member ?p ?o }";       
     
       
       
       long start2 = System.currentTimeMillis();
       try {
           //processor.executeAsynchronousSELECTQuery(query4,new SystemOutResultSink());
    	   processor.executeAsynchronousSELECTQuery(query5, new BufferedWriterResultSink("txt"));
       } catch ( Exception e ) {
           System.out.println("error: " + e);
       }
       System.out.println("Responce time (Query Execution): " + (System.currentTimeMillis() - start2) + " msec.");

        /*
       String s = MyUtilities.getStringFromFile("global_resultSet_RDF.rdf");
       
       System.out.println("String s from file: " + s);
       
       
       String a = MyUtilities.getStringFromFile("global_resultSet.txt");
       
       System.out.println("String s from file: " + a);
       
       */
   }

}